/*-
 * ~~~~~~licensing~~~~~~
 * events-api
 * ==========
 * Copyright (C) 2020 - 2021 EmDev LLC
 * ==========
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.esb.system.core.events.jpa;

import org.hibernate.Session;
import ru.entaxy.esb.system.core.events.common.SubscriptionType;
import ru.entaxy.esb.system.core.events.jpa.entity.EventTopic;
import ru.entaxy.esb.system.core.events.jpa.entity.SystemSubscription;
import ru.entaxy.esb.system.jpa.entity.System;

import java.util.List;

public interface SystemSubscriptionService {

    List<SystemSubscription> list();

    List<SystemSubscription> listByDeleted(boolean deleted);

    SystemSubscription get(long id);

    List<SystemSubscription> getBySystem(long systemRegistryId);

    SystemSubscription getBySystemAndTopic(long systemRegistryId, long eventTopicId);

    List<SystemSubscription> getByTopic(long eventTopicId);

    List<SystemSubscription> getByTopic(Session s, long eventTopicId);

    List<SystemSubscription> getByTopicAndType(long eventTopicId, SubscriptionType type);

    List<SystemSubscription> getByType(SubscriptionType type);

    SystemSubscription add(SystemSubscription systemSubscriptionRegistry) throws Exception;

    SystemSubscription add(System system, EventTopic eventTopic, SubscriptionType type) throws Exception;

    SystemSubscription update(SystemSubscription systemSubscriptionRegistry);

    void remove(long id);

    void removeByTopic(long eventTopicId);

    void removeByTopic(Session s, long eventTopicId);

    void markAsDeleted(long id, boolean deleted);

    void markAsDeletedByTopic(long eventTopicId, boolean deleted);

    void markAsDeletedByTopic(Session s, long eventTopicId, boolean deleted);

}
